SpeedyActions = LibStub("AceAddon-3.0"):NewAddon("SpeedyActions", "AceEvent-3.0")
SpeedyActions.supportedAddons = {}

local L = SpeedyActionsLocals
local CREATED_BUTTONS = 0
local buttonCache = {}

function SpeedyActions:OnInitialize()
	self.defaults = {
		profile = {
			
		}	
	}
	
	self.db = LibStub:GetLibrary("AceDB-3.0"):New("SpeedyActionsDB", self.defaults)
		
	for name, module in pairs(self.supportedAddons) do
		if( IsAddOnLoaded(name) ) then
			module:SupportLoaded()
		else
			self:RegisterEvent("ADDON_LOADED")
		end	
	end
end	

function SpeedyActions:GetButton(byType)
	-- Return a button that was created already
	for _, button in pairs(buttonCache) do
		if( not button.byType ) then
			button.byType = byType
			return button
		end
	end
	
	CREATED_BUTTONS = CREATED_BUTTONS + 1
	
	local button = CreateFrame("Button", "SpeedyActionsButtons" .. CREATED_BUTTONS, nil, "SecureActionButtonTemplate")
	button.byType = byType

	table.insert(buttonCache, button)
	return button
end

function SpeedyActions:ReleaseButtons(byType)
	for _, button in pairs(buttonCache) do
		if( button.byType == byType ) then
			button.byType = nil
		end	
	end
end

function SpeedyActions:ADDON_LOADED(event, addon)
	if( self.supportedAddons[addon] ) then
		self.supportedAddons[addon]:SupportLoaded()
	end
end

--[===[@debug@
SpeedyActionsLocals = setmetatable(SpeedyActionsLocals, {
	__index = function(tbl, value)
		rawset(tbl, value, value)
		return value
	end,
})
--@end-debug@]===]